"""
========================================
  Introduction to Computer Programming
========================================

-----------------------------------------------
  Programming Assignment 7
  Lists

  (YOUR NAME)

  ... status ...
-----------------------------------------------
"""


from random import randrange
from time import sleep

from mini_graphics import clear, paint, update, ROWS


# this was exercise 6 on Lab 9 we went over its solution in class on Thursday,
# November 10 here it is:
#
# insert_in_order is probably a little bit of a misnomer. The function is
# intended to be a step in the process of insertion_sort (see the first
# exercise on this homework, right below this). This function assumes that the
# first few elements from index 0 up to (but not necessarily including index
# stop) are already in increasing order. The value x is is to be inserted into
# that range of the list. In so doing, it will seem like an element of the list
# (the one at position stop) is being "over written", but used repeatedly, it
# allows to sort the items of a list without building a new list.
#
# Observe that the function does not use append - the length of a does not
# change.
def insert_in_order(a, stop, x):
    i = stop
    # keep "sliding" elements to the right to make room for x
    while i > 0 and x < a[i-1]:
        a[i] = a[i-1]
        i -= 1
    # we stop either once we hit the beginning of list
    # or first time x is bigger than an element we compare it against
    # then we put it into the list:
    a[i] = x


# here is how insert_in_order might be used to sort a short list:
# an unordered list:
#
# >>> a = [87, 54, 76, 43]
#
# >>> insert_in_order(a, 1, a[1])
# >>> a
#     [54, 87, 76, 43]   # now a is in order in first two positions
#
# >>> insert_in_order(a, 2, a[2])
# >>> a
#     [54, 76, 87, 43]   # now a is in order in first three positions
#
# >>> insert_in_order(a, 3, a[3])
# >>> a
#     [43, 54, 76, 87]   # now a is sorted!
#


# A. [was Lab 9, exercise 7] call insert_in_order in body of for/range
def insertion_sort(a):
    """Sorts elements of a in increasing order using insertion sort.

    >>> ns = [17, 3, 11, 19, 5, 7, 13]
    >>> insertion_sort(ns)
    >>> ns
    [3, 5, 7, 11, 13, 17, 19]
    """
    ...


# B. [was Lab 9, exercise 8] remember to call update at end
def visualize_list(a):
    """
    Draws elements of list at (x, y) where x is the index of element y. Assumes
    len(a) is no more than COLUMNS and that elements are integers between 0
    (inclusive) and ROWS (exclusive). List should appear all at once in
    graphics window.
    """
    ...


# C. [was Lab 9, exercise 9] call visualize_list; sort anyway you like
#    (selection, bubble, insertion); use sleep as needed
def visual_sort():
    """
    Builds a list of random numbers that fits in mini graphics window.
    Creates visual representation of list as it is being sorted.
    """
    ns = random_list(ROWS)
    visualize_list(ns)
    sleep(1)
    ...


# D. use for/range
def indexify(a):
    """...
    >>> my_list = ['alpha', 'beta', 'gamma', 'delta', 'epsilon']
    >>> indexify(my_list)
    >>> my_list
    [(0, 'alpha'), (1, 'beta'), (2, 'gamma'), (3, 'delta'), (4, 'epsilon')]
    """
    ...


# E. use for/range
# do not change the length of the list (so do not use append or pop)
def rotate_left(a):
    """
    Rotates the elements of list one place to the left. The first element
    comes off the "front" of the list and gets placed at the end.

    >>> my_list = ['alpha', 'beta', 'gamma', 'delta', 'epsilon']
    >>> rotate_left(my_list)
    >>> my_list
    ['beta', 'gamma', 'delta', 'epsilon', 'alpha']
    """
    ...


# F.
def ripple_pop(ns):
    """
    Removes last number of nonempty list of numbers ns and adds to it all
    remaining numbers on list. Returns what was removed.

    >>> ns = [5, 1, 6]
    >>> ripple_pop(ns)
    6
    >>> ns
    [11, 7]
    >>> ripple_pop(ns)
    7
    >>> ns
    [18]
    >>> ripple_pop(ns)
    18
    >>> ns
    []
    """
    ...
    return ...


# G.
def count_streaks(s):
    """
    Returns a list based on string s where each item in the list is a pair with
    the fist part of the pair being a character in s and the second part the
    number of times it occurs in a row.

    >>> count_streaks('hello')
    [('h', 1), ('e', 1), ('l', 2), ('o', 1)]
    >>> count_streaks('---------->   wow!!!')
    [('-', 10), ('>', 1), (' ', 3), ('w', 1), ('o', 1), ('w', 1), ('!', 3)]
    """
    a = []
    if len(s) > 0:
        count = 1
        last = s[0]
        for i in range(1, len(s)):
            if s[i] == last:
                count += 1
            else:
                a.append((last, count))
                last = s[i]
                count = 1
        a.append((last, count))
    return a


# H.
def partition(xs):
    """
    Rearranges items in nonempty list xs such that whatever was in first
    position (called the "pivot value") is moved so that all the items
    occurring before the pivot value are less than it and all the items
    occurring after the pivot value are greater than it. Returns the index
    where the pivot value lands. Assumes that items on xs are unique (no
    duplicates occur in xs).

    >>> words = ['delta', 'beta', 'gamma', 'alpha']   # pivot is 'delta'
    >>> partition(words)
    2
    >>> words
    ['beta', 'alpha', 'delta', 'gamma']
    >>> ns = [74, 89, 80, 20, 43, 7, 32, 71, 25, 47]   # pivot is 74
    >>> partition(ns)
    7
    >>> ns
    [47, 25, 20, 43, 7, 32, 71, 74, 80, 89]
    """
    p = 0
    ...
    return p


# -------------------------------------------------------------------------
# ------ some helpful code we have seen before ------
#
def random_list(n):
    """Returns list of length n with random integers between 0 and n."""
    a = []
    for _ in range(n):
        a.append(randrange(n))
    return a


def swap(a, i, j):
    t = a[i]
    a[i] = a[j]
    a[j] = t
